%define name	sendmail 
%define version 8.11.0
%define release 3mdk 

Summary:	A widely used Mail Transport Agent (MTA)
Name:		%{name}
Version:	%{version}
Release:	%{release}
Copyright:	BSD
Group:		System/Servers
Provides:	smtpdaemon

Source0:	ftp://ftp.sendmail.org/pub/sendmail/%{name}.%{version}.tar.bz2
Source1:	sendmail.init
Source2:	http://www.informatik.uni-kiel.de/%7Eca/email/rules/check.tar.bz2
Source3:	aliases
Source4:	sendmail.sysconfig
Source5:	sendmail-8.9.3-etc-mail-Makefile
Source6:	sendmail-redhat.mc

Patch0:		sendmail-8.11.0-redhat.patch
Patch1:		sendmail-8.10.0-makemapman.patch
Patch2:		sendmail-8.10.0-smrsh-paths.patch
Patch3:		sendmail-8.8.7-rmail.patch
Patch4:		sendmail-8.10.0-aliasesDoS.patch
Patch5:		sendmail-8.10.0-movefiles.patch

Buildroot:	%{_tmppath}/%{name}-%{version}-buildroot
Prereq:		/sbin/chkconfig

%description
The Sendmail program is a very widely used Mail Transport Agent (MTA). MTAs send
mail from one machine to another.

Sendmail is not a client program, which you use to read your e-mail. Sendmail
is a behind-the-scenes program which actually moves your e-mail over networks
or the Internet to where you want it to go.

If you ever need to reconfigure Sendmail, you'll also need to have the
sendmail.cf package installed.  If you need documentation on Sendmail, you can
install the sendmail-doc package.

%package doc
Summary:	Documentation about the Sendmail Mail Transport Agent program
Group:		System/Servers 

%description doc
The sendmail-doc package contains documentation about the Sendmail
Mail Transport Agent (MTA) program, including release notes, the
Sendmail FAQ and a few papers written about Sendmail.  The papers are
provided in PostScript(TM) and troff formats.

Install the sendmail-doc package if you need documentation about
Sendmail.

%package cf
Summary:	The files needed to reconfigure Sendmail
Group:		System/Servers

%description cf
This package includes the configuration files which you'd need to generate the
sendmail.cf file distributed with the sendmail package.

You'll need the sendmail-cf package if you ever need to reconfigure and rebuild
your sendmail.cf file. For example, the default sendmail.cf file is not
configured for UUCP. If someday you needed to send and receive mail over UUCP,
you'd need to install the sendmail-cf package to help you reconfigure Sendmail.

Install the sendmail-cf package if you need to reconfigure your
sendmail.cf file.

%prep

%setup -q
%patch0 -p1 -b .redhat
%patch1 -p1 -b .makemapman
%patch2 -p1 -b .smrsh
%patch3 -p1 -b .rmail
%patch4 -p1 -b .aliases
%patch5 -p1 -b .movestuff

# XXX REVERTING
#tar xf $RPM_SOURCE_DIR/check.tar -C cf
#chown root.root cf/hack/* cf/README.check


sed -e 's|@@PATH@@|\.\.|' < %{SOURCE6} > cf/cf/redhat.mc

%build
export RPM_OPT_FLAGS="$RPM_OPT_FLAGS -DUSE_VENDOR_CF_PATH=1"

cd sendmail
sh Build -f ../redhat.config.m4
cd ..

cd mailstats
sh Build -f ../redhat.config.m4
cd ..

cd rmail
sh Build -f ../redhat.config.m4
cd ..

cd makemap
sh Build -f ../redhat.config.m4
cd ..

cd praliases
sh Build -f ../redhat.config.m4
cd ..

cd smrsh
sh Build -f ../redhat.config.m4
cd ..

cd cf/cf
m4 redhat.mc > redhat.cf
cd ../..

cd vacation
sh Build -f ../redhat.config.m4

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
for i in usr/bin  usr/lib %{_mandir}/man{1,5,8}  usr/sbin \
		 var/log  var/spool  usr/lib/sendmail-cf  %{_initrddir} \
		 etc/sysconfig
	do
	mkdir -p  $RPM_BUILD_ROOT/${i}
	done

%ifarch ppc
mkdir -p usr/share usr/share/man
ln -s $RPM_BUILD_ROOT/usr/man/man1 $RPM_BUILD_ROOT%{_mandir}/cat1
ln -s $RPM_BUILD_ROOT/usr/man/man5 $RPM_BUILD_ROOT%{_mandir}/cat5
ln -s $RPM_BUILD_ROOT/usr/man/man8 $RPM_BUILD_ROOT%{_mandir}/cat8
ln -s $RPM_BUILD_ROOT/usr/sbin $RPM_BUILD_ROOT/usr/libexec
%endif


OBJDIR=obj.$(uname -s).$(uname -r).$(arch)

%makeinstall \
	 DESTDIR=$RPM_BUILD_ROOT \
	 SBINOWN=`id -nu` UBINOWN=`id -nu` \
	 SBINGRP=`id -ng`  UBINGRP=`id -ng` \
	 MANOWN=`id -nu`  MANGRP=`id -ng`  \
	 MANROOT="%{_mandir}/man"

#make DESTDIR=$RPM_BUILD_ROOT SBINOWN=`id -nu` UBINOWN=`id -nu` SBINGRP=`id -ng` UBINGRP=`id -ng` MANOWN=`id -nu` MANGRP=`id -ng` \
# install -C $OBJDIR/praliases
make DESTDIR=$RPM_BUILD_ROOT SBINOWN=`id -nu` UBINOWN=`id -nu` SBINGRP=`id -ng` UBINGRP=`id -ng` MANOWN=`id -nu` MANGRP=`id -ng` \
MANROOT="%{_mandir}/man" \
 force-install -C $OBJDIR/rmail
make DESTDIR=$RPM_BUILD_ROOT SBINOWN=`id -nu` UBINOWN=`id -nu` SBINGRP=`id -ng` UBINGRP=`id -ng` MANOWN=`id -nu` MANGRP=`id -ng` \
 MANROOT="%{_mandir}/man" \
 force-install -C $OBJDIR/mail.local
#make DESTDIR=$RPM_BUILD_ROOT SBINOWN=`id -nu` UBINOWN=`id -nu` SBINGRP=`id -ng` UBINGRP=`id -ng` MANOWN=`id -nu` MANGRP=`id -ng` \
# install -C $OBJDIR/makemap

ln -sf ../sbin/makemap $RPM_BUILD_ROOT/usr/bin/makemap

# install docs by hand
cp smrsh/README README.smrsh
cp cf/README README.cf

# install the cf files
cd cf
cp -ar * $RPM_BUILD_ROOT/usr/lib/sendmail-cf

cd -
mkdir -p $RPM_BUILD_ROOT/etc/mail
install -m 644 cf/cf/redhat.cf $RPM_BUILD_ROOT/etc/sendmail.cf
sed -e 's|@@PATH@@|/usr/lib/sendmail-cf|' < %{SOURCE6} > $RPM_BUILD_ROOT/etc/mail/sendmail.mc
echo "# local-host-names - include all aliases for your machine here." > $RPM_BUILD_ROOT/etc/mail/local-host-names

ln -sf ../sbin/sendmail $RPM_BUILD_ROOT/usr/lib/sendmail
install -d -m755 $RPM_BUILD_ROOT/var/spool/mqueue

# dangling symlinks
for f in hoststat mailq newaliases purgestat
  do
    ln -sf ../sbin/sendmail $RPM_BUILD_ROOT/usr/bin/${f}
  done
mkdir -p $RPM_BUILD_ROOT/etc/smrsh

cat <<EOF > $RPM_BUILD_ROOT/etc/mail/access
# Check the /usr/doc/sendmail-%{version}/README.cf file for a description
# of the format of this file. (search for access_db in that file)
# The /usr/doc/sendmail-%{version}/README.cf is part of the sendmail-doc
# package.
#
# by default we allow relaying from localhost...
localhost.localdomain		RELAY
localhost			RELAY
127.0.0.1			RELAY

EOF
for map in virtusertable access domaintable mailertable
  do
    touch $RPM_BUILD_ROOT/etc/mail/${map}
    chmod 0644 $RPM_BUILD_ROOT/etc/mail/${map}
    $RPM_BUILD_ROOT/usr/bin/makemap -C $RPM_BUILD_ROOT/etc/sendmail.cf hash $RPM_BUILD_ROOT/etc/mail/${map}.db < $RPM_BUILD_ROOT/etc/mail/${map}
    chmod 0644 $RPM_BUILD_ROOT/etc/mail/${map}.db
  done
install -m644 %{SOURCE3} $RPM_BUILD_ROOT/etc/aliases
$RPM_BUILD_ROOT/usr/bin/makemap -C $RPM_BUILD_ROOT/etc/sendmail.cf hash $RPM_BUILD_ROOT/etc/aliases.db < %{SOURCE3}

install -m644 %SOURCE4 $RPM_BUILD_ROOT/etc/sysconfig/sendmail
install -m755 %SOURCE1 $RPM_BUILD_ROOT%{_initrddir}/sendmail

install -m 644 %{SOURCE5} $RPM_BUILD_ROOT/etc/mail/Makefile

chmod u+w $RPM_BUILD_ROOT/usr/sbin/{mailstats,praliases}
chmod u+w $RPM_BUILD_ROOT/usr/bin/rmail


# Dadou: Remove ugly bad dependencies in doc package
perl -p -i -e "s|/usr/local/bin/perl|/usr/bin/perl|" contrib/*
perl -p -i -e "s|#\!/bin/perl|#\!/usr/bin/perl|" contrib/passwd-to-alias.pl


%clean
rm -fr $RPM_BUILD_ROOT

%post
#
# Convert old format to new
#
if [ -f /etc/mail/deny ] ; then
    cat /etc/mail/deny | \
	awk 'BEGIN{ print "# Entries from obsoleted /etc/mail/deny"} \
		  {print $1" REJECT"}' >> /etc/mail/access
    cp /etc/mail/deny /etc/mail/deny.rpmorig
fi
for oldfile in relay_allow ip_allow name_allow ; do
    if [ -f /etc/mail/$oldfile ] ; then
	cat /etc/mail/$oldfile | \
		awk "BEGIN { print \"# Entries from obsoleted /etc/mail/$oldfile\" ;} \
	     { print $1\" RELAY\" }" >> /etc/mail/access
	cp /etc/mail/$oldfile /etc/mail/$oldfile.rpmorig
     fi
done

#
# Oops, these files moved
#
if [ -f /etc/sendmail.cw ] ; then
    cat /etc/sendmail.cw  | \
      awk 'BEGIN { print "# Entries from obsoleted /etc/sendmail.cw" ;} \
           { print $1 }' >> /etc/mail/local-host-names
    cp /etc/sendmail.cw /etc/sendmail.cw.rpmorig
fi
#
# Rebuild maps (next reboot will rebuild also)
#
{ /usr/bin/newaliases
  for map in virtusertable access domaintable mailertable
  do
    if [ -f /etc/mail/${map} ] ; then
      /usr/bin/makemap hash /etc/mail/${map} < /etc/mail/${map}
      sleep 1
    fi
  done
} > /dev/null 2>&1

/sbin/chkconfig --add sendmail

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del sendmail
fi

# removal of compatibility links
%triggerpostun -- sendmail < 8.10.0
/sbin/chkconfig --add sendmail

%files
%defattr(0555,bin,bin)
/usr/bin/hoststat
/usr/bin/purgestat
/usr/bin/rmail
/usr/bin/makemap
/usr/bin/newaliases
/usr/bin/mailq
/usr/bin/vacation
/usr/sbin/mail.local
/usr/sbin/makemap
/usr/sbin/sendmail
/usr/sbin/mailstats
/usr/sbin/praliases
/usr/sbin/smrsh
/usr/lib/sendmail

/usr/share/man/man1/*
/usr/share/man/man5/*
/usr/share/man/man8/*

/var/log/statistics

# XXX can't do noreplace here or new sendmail will not deliver.
%defattr(0644,root,root)
%config(noreplace)		/etc/sendmail.cf
%config(noreplace)		/etc/aliases
%attr(0644,root,mail) %ghost	/etc/aliases.db
%attr(0644,root,root) %config	/etc/mail/sendmail.mc
%config(noreplace)		/etc/mail/local-host-names
%config /etc/mail/Makefile
%ghost			/etc/mail/virtusertable.db
%config(noreplace)	/etc/mail/virtusertable
%ghost			/etc/mail/access.db
%config(noreplace)	/etc/mail/access
%ghost			/etc/mail/domaintable.db
%config(noreplace)	/etc/mail/domaintable
%ghost			/etc/mail/mailertable.db
%config(noreplace)	/etc/mail/mailertable
%config(noreplace)	/etc/mail/helpfile
%config(noreplace) /etc/sysconfig/sendmail
%attr(0755,root,root) %config(noreplace) %{_initrddir}/sendmail

%attr(0755,root,root) %dir /etc/smrsh
%attr(0755,root,root) %dir /etc/mail
%attr(0755,root,mail) %dir	/var/spool/mqueue

%files cf
%defattr(-,root,root)
/usr/lib/sendmail-cf

%files doc
%defattr(-,root,root)
%doc FAQ LICENSE KNOWNBUGS README RELEASE_NOTES doc
%doc README.smrsh README.cf contrib 


%changelog
* Mon Sep  4 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 8.11.0-3mdk 
- config-noreplace initscript

* Thu Aug 26 2000 David BAUDENS <baudens@mandrakesoft.com> 8.11.0-2mdk
- Fix bad dependencies on Perl
- %config(noreplace) /etc/sendmail.cf

* Wed Aug 23 2000 Philippe Libat <philippe@mandrakesoft.com> 8.11.0-1mdk
- version 8.11.0
- replace %_mandir, %_initrddir

* Fri May 12 2000 Saugey Vincent <vince@mandrakesoft.com> 8.10.1-2mdk
- Fix good directory to use makemap with sendmail installed
- Remove strip of file

* Mon Apr 17 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 8.10.1-1mdk
- updated to 8.10.1
- re-did ppc fixes
- Merged with RedHat:
  remove compatiblity chkconfig links
  break the hard link for makemap and create it as a symlnk (#8223)
  change perms on /etc/sysconfig/sendmail from 0755 to 0644
  allow compressed man-pages
  add patch to prevent the DoS when rebuilding aliases
  Fix location of mailertable (Bug #6035)
  fixes for non-root builds (#8178)
  install man pages, not groff output (#3746).
  use dnl not '#' in m4 comment (#3749).
  add FEATURE(mailtertable) to the config -- example file needs this (#4649).

* Mon Mar 27 2000 Frederic Lepied <flepied@mandrakesoft.com> 8.9.3-22mdk
- fixed install step not to depend on already installed stuff.
- new groups.

* Sun Mar 19 2000 John Buswell <johnb@mandrakesoft.com> 8.9.3-21mdk
- Added PPC fixes

* Wed Jan 12 2000 Philippe Libat <philippe@mandrakesoft.com>
- Add attr to aliases.db in sendmail.spec

* Wed Nov 10 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Die if lord postfix is present.

* Tue Oct 26 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Merge with redhat patch.

* Wed Jul 07 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- more sleep deprivation derived type-o's

* Wed Jul 07 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- sendmail init now checks for postfix

* Sat Apr 10 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Mandrake adaptions
- bzip2 man/info pages
- add de locale
- fix handling of RPM_OPT_FLAGS

* Tue Mar 16 1999 Cristian Gafton <gafton@redhat.com>
- version 8.9.3

* Tue Dec 29 1998 Cristian Gafton <gafton@redhat.com>
- build for 6.0
- use the libdb1 stuff correctly

* Mon Sep 21 1998 Michael K. Johnson <johnsonm@redhat.com>
- Allow empty QUEUE in /etc/sysconfig/sendmail for those who
  want to run sendmail in daemon mode without processing the
  queue regularly.

* Thu Sep 17 1998 Michael K. Johnson <johnsonm@redhat.com>
- /etc/sysconfig/sendmail

* Fri Aug 28 1998 Jeff Johnson <jbj@redhat.com>
- recompile statically linked binary for 5.2/sparc

* Tue May 05 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- enhanced initscripts

* Fri May 01 1998 Cristian Gafton <gafton@redhat.com>
- added a rmail patch

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- argh!  Fixed some of the db1 handling that had to be added for glibc 2.1

* Fri Oct 24 1997 Donnie Barnes <djb@redhat.com>
- added support for db1 on SPARC

* Thu Oct 16 1997 Donnie Barnes <djb@redhat.com>
- added chkconfig support
- various spec file cleanups
- changed group to Networking/Daemons (from Daemons).  Sure, it runs on
  non networked systems, but who really *needs* it then?

* Wed Oct 08 1997 Donnie Barnes <djb@redhat.com>
- made /etc/mail/deny.db a ghost
- removed preun that used to remove deny.db (ghost handles that now)
- NOTE: upgrading from the sendmail packages in 4.8, 4.8.1, and possibly
  4.9 (all Red Hat betas between 4.2 and 5.0) could cause problems.  You
  may need to do a makemap in /etc/mail and a newaliases after upgrading
  from those packages.  Upgrading from 4.2 or prior should be fine.

* Mon Oct 06 1997 Erik Troan <ewt@redhat.com>
- made aliases.db a ghost

* Tue Sep 23 1997 Donnie Barnes <djb@redhat.com>
- fixed preuninstall script to handle aliases.db on upgrades properly

* Mon Sep 15 1997 Donnie Barnes <djb@redhat.com>
- fixed post-install output and changed /var/spool/mqueue to 755

* Thu Sep 11 1997 Donnie Barnes <djb@redhat.com>
- fixed /usr/lib/sendmail-cf paths

* Tue Sep 09 1997 Donnie Barnes <djb@redhat.com>
- updated to 8.8.7
- added some spam filtration
- combined some makefile patches
- added BuildRoot support

* Wed Sep 03 1997 Erik Troan <ewt@redhat.com>
- marked initscript symlinks as missingok
- run newalises after creating /var/spool/mqueue

* Thu Jun 12 1997 Erik Troan <ewt@redhat.com>
- built against glibc, udated release to -6 (skipped -5!)

* Tue Apr 01 1997 Erik Troan <ewt@redhat.com>
- Added -nsl on the Alpha (for glibc to provide NIS functions).

* Mon Mar 03 1997 Erik Troan <ewt@redhat.com>
- Added nis support.
